angular.module('beamng.apps')

.directive('trafficTool', ['bngApi', function (bngApi) {
	return {
		templateUrl: 'modules/apps/trafficTool/app.html',
		replace: false,
		restrict: 'E',
		scope: false,
		controller: function ($scope, $element, $attrs) {
			$scope.checkImg = "url(modules/apps/trafficTool/checkmark.png)";
			$scope.mainStyle = {appWidth: "100%", appHeight: "100%", inLeft: "auto", inRight: "4px", appShow: "visible", groupsShow: "hidden"};
			$scope.checkStyle = {awareness: $scope.checkImg, method: ""};
			$scope.visible = {main: true};
			$scope.inSymbol = "-";
			$scope.unit = "km/h";
			$scope.metric = true;
			$scope.check = {awareness: true, method: false};
			$scope.quantity = 1;
			$scope.speedLimit = 50;
			$scope.respawnRate = 1;
			$scope.colorModeOptions = [
				{mode: 1, txt: "Unchanged"}, {mode: 2, txt: "Standard"}, {mode: 3, txt: "Random"}
			];
			$scope.aiModeOptions = [
				{mode: 1, txt: "Normal"}, {mode: 2, txt: "Flee"}, {mode: 3, txt: "Chase"}, {mode: 4, txt: "Disabled"}
			];
			
			this.init = function() {
				var command = `extensions.freeroam_dynamicTraffic.ready()`;
				bngApi.engineLua(command);
			}
			
			this.toggleAll = function() {
				$scope.visible.main = !$scope.visible.main;
				if($scope.visible.main == false) {
					$scope.mainStyle = {appWidth: "24px", appHeight: "24px", inLeft: "4px", inRight: "auto", appShow: "hidden", groupsShow: "hidden"};
					$scope.inSymbol = "+";
				} else {
					$scope.mainStyle = {appWidth: "100%", appHeight: "100%", inLeft: "auto", inRight: "4px", appShow: "visible", groupsShow: "hidden"};
					$scope.inSymbol = "-";
				}
			}
			
			this.showGroups = function() {
				$scope.mainStyle.groupsShow = "visible";
			}
			
			this.setGroup = function(n) {
				$scope.mainStyle.groupsShow = "hidden";
				var command = `extensions.freeroam_dynamicTraffic.setGroup(` + n + `)`;
				bngApi.engineLua(command);
			}
			
			this.toggleUnits = function() {
				$scope.metric = !$scope.metric;
				if($scope.metric == false) {
					$scope.unit = "mph";
				} else {
					$scope.unit = "km/h";
				}
				var command = `extensions.freeroam_dynamicTraffic.toggleUnits(` + Number($scope.metric) + `)`;
				bngApi.engineLua(command);
			}
			
			this.toggleAwareness = function() {
				$scope.check.awareness = !$scope.check.awareness;
				if($scope.check.awareness == false) {
					$scope.checkStyle.awareness = "";
				} else {
					$scope.checkStyle.awareness = $scope.checkImg;
				}
				var command = `extensions.freeroam_dynamicTraffic.toggleAwareness(` + Number($scope.check.awareness) + `)`;
				bngApi.engineLua(command);
			}
			
			this.toggleMethod = function() {
				$scope.check.method = !$scope.check.method;
				if($scope.check.method == false) {
					$scope.checkStyle.method = "";
				} else {
					$scope.checkStyle.method = $scope.checkImg;
				}
				var command = `extensions.freeroam_dynamicTraffic.toggleMethod(` + Number($scope.check.method) + `)`;
				bngApi.engineLua(command);
			}
			
			this.setQuantity = function() {
				var command = `extensions.freeroam_dynamicTraffic.setQuantity(${this.quantity})`;
				bngApi.engineLua(command);
			}
			
			this.spawnVehicles = function() {
				var command = `extensions.freeroam_dynamicTraffic.spawnVehicles()`;
				bngApi.engineLua(command);
			}
			
			this.deleteVehicles = function() {
				var command = `extensions.freeroam_dynamicTraffic.deleteVehicles()`;
				bngApi.engineLua(command);
			}
			
			this.activateVehicles = function() {
				var command = `extensions.freeroam_dynamicTraffic.activateVehicles()`;
				bngApi.engineLua(command);
			}
			
			this.setSpeedLimit = function() {
				var command = `extensions.freeroam_dynamicTraffic.setSpeedLimit(${this.speedLimit})`;
				bngApi.engineLua(command);
			}
			
			this.setRespawnRate = function() {
				var command = `extensions.freeroam_dynamicTraffic.setRespawnRate(${this.respawnRate})`;
				bngApi.engineLua(command);
			}
			
			this.setColorMode = function() {
				var command = `extensions.freeroam_dynamicTraffic.setColorMode(${this.colorModeOptions.mode})`;
				bngApi.engineLua(command);
			}
			
			this.setAiMode = function() {
				var command = `extensions.freeroam_dynamicTraffic.setAiMode(${this.aiModeOptions.mode})`;
				bngApi.engineLua(command);
			}	
		},
		controllerAs: 'ctrl'
	};
}]);